<template>
  <div class="container">

    <span v-if="saveError">
      <div class="alert alert-danger" role="alert">{{ saveError }}</div>
    </span>

    <form method="post">
      <div class="form-group">
        <label for="codeEl">
          Eesti isikukood või ettevõtte registrikood
          <input type="text" class="form-control" id="codeEl" v-model="pCode" maxlength="11" />
        </label>
      </div>
      <div class="form-group">
        <label for="nameEl">
          Nimi
          <input type="text" class="form-control" id="nameEl" v-model="pName"/>
        </label>
      </div>
      <div class="form-group">
        <label for="surnameEl">
          Perekonnanimi (ettevõtte korral jäta tühjaks)
          <input type="text" class="form-control" id="surnameEl" v-model="pSurname" />
        </label>
      </div>
      <div class="form-group">
        <label for="payEl">
          Makseviis
          <select class="form-select" aria-label="Makseviis" id="payEl" v-model="payType">
            <option value="SULARAHA" selected>SULARAHA</option>
            <option value="ÜLEKANNE">ÜLEKANNE</option>
          </select>
        </label>
      </div>
      <div class="form-group">
        <label for="moreEl">
          Lisainfo
          <textarea class="form-control" id="moreEl" v-model="moreInfo" />
        </label>
      </div>
      <router-link to="/">tagasi</router-link>
      <button type="button" @click="submitForm" class="btn btn-primary">Lisa</button>
    </form>
  </div>
</template>

<script>
import axios from 'axios';
import useValidate from '@vuelidate/core';
import { required } from '@vuelidate/validators';

export default {
  name: 'AddGuest',
  data() {
    return {
      v$: useValidate(),
      pCode: '',
      pName: '',
      pSurname: '',
      payType: 'SULARAHA',
      moreInfo: '',
      saveError: null,
    };
  },
  methods: {
    submitForm() {
      this.v$.$validate();
      this.saveError = null;
      if (!this.v$.$error) {
        axios.post(
          `http://localhost:5000/yritus/${this.$route.params.event_uid}/kylaline`,
          {
            kood: this.pCode,
            eesnimi: this.pName,
            perenimi: this.pSurname,
            makseviis: this.payType,
            lisainfo: this.moreInfo,
          },
          { headers: { 'Content-type': 'application/json' } },
        ).then(() => {
          this.$router.push(`/event/${this.$route.params.event_uid}`);
        }).catch((error) => {
          this.saveError = error.response.data.detail;
        });
      } else {
        return false;
      }
      return true;
    },
  },
  validations() {
    return {
      pCode: { required },
      pName: { required },
      payType: { required },
    };
  },
};
</script>
